<?php

namespace App\Http\Controllers\Admin;

/** Ajax Request */

use App\Exports\MemberExport;
use App\Http\Requests\Admin\NotificationRequest;
use App\Models\Notification;
use App\Services\Interfaces\NotificationRepositoryInterface;
use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use Illuminate\Http\RedirectResponse;
use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;

class NotificationController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/notifications';
    /** View folder */
    private $viewDirectory= 'admin.notifications.';
    //
    private NotificationRepositoryInterface $notificationRepository;

    public function __construct(NotificationRepositoryInterface $notificationRepository)
    {
        $this->notificationRepository = $notificationRepository;
    }

    /**
     * Display a listing of the notifications.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('notifications.head');
        $statuses = ['all','specific'];
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the notifications.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) //:View
    {
        $request->merge(['paginate'=> true]);
        $notifications= $this->notificationRepository->get($request);

        return view($this->viewDirectory.'grid',compact('notifications'));
    }

    /**
     * Show the form for creating a new Notification.
     *
     * @return View
     */
    public function create(Request $request) :View
    {
        $action= route('notifications.store');
        $head= __('notifications.new');
        $statuses = ['specific','all'];
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Notification in storage.
     * @param NotificationRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(NotificationRequest $request) :JsonResponse
    {
        $notification= $this->notificationRepository->save($request, null);

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('notifications.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Notification.
     *
     * @param  Notification  $notification
     * @return View
     */
    public function edit(Notification $notification) :View
    {
        // dd($notification->id);
        $action= route('notifications.update', $notification->id);
        $data= $this->notificationRepository->getItem($notification);
        $head= __('notifications.edit');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Notification in storage.
     * @param NotificationRequest $request
     * @param Notification $notification
     * @return RedirectResponse|Redirector
     */
    public function update(NotificationRequest $request, Notification $notification) :JsonResponse
    {
        $notification= $this->notificationRepository->save($request, $notification);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('notifications.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Notification from storage.
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $return= $this->notificationRepository->destroy($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Remove several notifications by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $return= $this->notificationRepository->destroyAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore the specified Notification from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $return= $this->notificationRepository->restore($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore several notifications by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $return= $this->notificationRepository->restoreAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }
}
